#define SIGEL_USE_ONLY


//#define SIGEL_DEVIL
//#define SIGEL_SOUND
//#define SIGEL_SCRIPT
//#define SIGEL_PHYSX
//#define SIGEL_NETWORK

#include <sigel/ISigel.h>

Billboard *expbb = 0;
Texture *texexp = 0;

float csize = 25.0f;

float tm;

class Explode
{
	Entity* ent;
	float frame;
public:
	Explode();
	~Explode();

	void Update();
};

typedef std::list<Explode*> Texplist;
Texplist explist;

Explode::Explode()
{
	ent = new Entity(expbb);
	ent->BindTex(texexp);
	ent->Blend(BM_ADD);

	ent->Position(rnd(-csize,csize),rnd(-csize,csize),rnd(-csize,csize));
	frame = rnd(0,38);
	explist.push_back(this);
}

Explode::~Explode()
{
	delete ent;
	explist.remove(this);
}

void Explode::Update()
{
	frame+=min_(tm,1.0f);

	if(frame>39)
	{
		frame = rnd(1,3);
		//ent->Position(rnd(-csize,csize),rnd(-csize,csize),rnd(-csize,csize));
		ent->SetFrame(frame);
	}
	else
	{
		ent->SetFrame(frame);
	}
}

sGAME
{
	debug::startlog();
	Init(1024,768,32,2,0);
	AppTitle("ExplodesBenchmark");

	VWait(0);
	CameraHelper ch;

	TFont *fnt = new TFont("tahoma.txt");

	expbb = new Billboard(2.2f);
	texexp = new Texture("boomstrip2.bmp");

	expbb->AnimLenght(40);

	for(int i=0;i<500;++i)
	{
			Explode *temp = new Explode();
	}

	int cnt = 0;

	ch.SetMoveSmooth(0);
	float ft=0;
	while(!KeyDown(VK_ESCAPE))
	{
		if(KeyDown('1'))
			expbb->SetSmoothAnim(0);

		if(KeyDown('2'))
		{
			expbb->SetSmoothAnim(1);
		}

		//3d
		ft = GetFrameTime();
		tm = ft/1000.0f * 4.0f;

		ch.SetMoveSpeed(ft*0.01f);

		if(KeyDown(VK_SPACE))
			tm = 1;

		misc::update_this<Texplist>(explist);

		ch.Update();
		Render();
		//2d

		fnt->Text(GetFPS(),10,10);
		fnt->Text(RenderedTris(),10,25);

		fnt->Text(cams::v1.x * 100,10,50);
		fnt->Text(cams::v1.y * 100,60,50);
		fnt->Text(cams::v1.z * 100,110,50);

		fnt->Text(cams::v2.x * 100,10,70);
		fnt->Text(cams::v2.y * 100,60,70);
		fnt->Text(cams::v2.z * 100,110,70);

		Flip();
	}

	DeInit();
	debug::endlog();
};